<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_gmb".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeGmb".
 *
 * Columns in table "provider_practice_gmb" available as properties of the model,
 * followed by relations of table "provider_practice_gmb" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property integer $is_read_only
 * @property integer $apply_dr_booking_url
 * @property integer $apply_dr_description
 * @property integer $has_sync_issues
 * @property string $sync_issues_details
 * @property integer $has_localposts_api
 * @property string $is_claimed_by
 * @property string $escalation
 * @property string $location_name_override
 * @property string $date_added
 * @property string $date_updated
 * @property string $date_last_sync
 * @property integer $provider_practice_listing_id
 * @property integer $added_by_account_id
 * @property integer $updated_by_account_id
 * @property string $place_id
 * @property string $category_1
 * @property string $category_2
 * @property string $category_3
 * @property integer $link_verified
 * @property integer $sync_tracking_number
 * @property integer $sync_cover
 * @property integer $sync_address
 * @property integer $sync_website
 * @property integer $skip
 * @property integer $create
 * @property integer $merge
 * @property integer $close
 * @property integer $verify
 * @property integer $claim
 * @property integer $request_ownership
 * @property integer $integrate
 *
 * @property GmbLocation[] $gmbLocations
 * @property GmbLocationStats[] $gmbLocationStats
 * @property Account $account
 * @property Practice $practice
 * @property Provider $provider
 * @property ProviderPracticeListing $providerPracticeListing
 * @property ProviderPracticeGmbDataPoint[] $providerPracticeGmbDataPoints
 * @property ProviderPracticeGmbLocationState $providerPracticeGmbLocationState
 * @property ProviderPracticeGmbVerification[] $providerPracticeGmbVerifications
 */
abstract class BaseProviderPracticeGmb extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_gmb';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeGmb|ProviderPracticeGmbs', $n);
    }

    public static function representingColumn()
    {
        return 'is_claimed_by';
    }

    public function rules()
    {
        return array(
            array('account_id, practice_id, date_added, date_updated, added_by_account_id', 'required'),
            array('account_id, practice_id, provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, has_localposts_api, provider_practice_listing_id, added_by_account_id, updated_by_account_id, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate', 'numerical', 'integerOnly'=>true),
            array('is_claimed_by', 'length', 'max'=>8),
            array('escalation', 'length', 'max'=>2),
            array('location_name_override', 'length', 'max'=>150),
            array('place_id', 'length', 'max'=>30),
            array('category_1, category_2, category_3', 'length', 'max'=>50),
            array('sync_issues_details, date_last_sync', 'safe'),
            array('provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, sync_issues_details, has_localposts_api, is_claimed_by, escalation, location_name_override, date_last_sync, provider_practice_listing_id, updated_by_account_id, place_id, category_1, category_2, category_3, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, practice_id, provider_id, is_read_only, apply_dr_booking_url, apply_dr_description, has_sync_issues, sync_issues_details, has_localposts_api, is_claimed_by, escalation, location_name_override, date_added, date_updated, date_last_sync, provider_practice_listing_id, added_by_account_id, updated_by_account_id, place_id, category_1, category_2, category_3, link_verified, sync_tracking_number, sync_cover, sync_address, sync_website, skip, create, merge, close, verify, claim, request_ownership, integrate', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'gmbLocations' => array(self::HAS_MANY, 'GmbLocation', 'provider_practice_gmb_id'),
            'gmbLocationStats' => array(self::HAS_MANY, 'GmbLocationStats', 'provider_practice_gmb_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'providerPracticeListing' => array(self::BELONGS_TO, 'ProviderPracticeListing', 'provider_practice_listing_id'),
            'providerPracticeGmbDataPoints' => array(self::HAS_MANY, 'ProviderPracticeGmbDataPoint', 'provider_practice_gmb_id'),
            'providerPracticeGmbLocationState' => array(self::HAS_ONE, 'ProviderPracticeGmbLocationState', 'provider_practice_gmb_id'),
            'providerPracticeGmbVerifications' => array(self::HAS_MANY, 'ProviderPracticeGmbVerification', 'provider_practice_gmb_id'),
            'gmbCategory' => array(self::BELONGS_TO, 'GmbCategory', 'category_1'),
            'providerPractice' => array(self::BELONGS_TO, 'ProviderPractice', 'provider_id'),
            'salesforceEntityMapping' => array(self::HAS_MANY, 'SalesforceEntityMapping', 'entity_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'practice_id' => null,
            'provider_id' => null,
            'is_read_only' => Yii::t('app', 'Is Read Only'),
            'apply_dr_booking_url' => Yii::t('app', 'Apply Dr Booking Url'),
            'apply_dr_description' => Yii::t('app', 'Apply Dr Description'),
            'has_sync_issues' => Yii::t('app', 'Has Sync Issues'),
            'sync_issues_details' => Yii::t('app', 'Sync Issues Details'),
            'has_localposts_api' => Yii::t('app', 'Has Localposts Api'),
            'is_claimed_by' => Yii::t('app', 'Is Claimed By'),
            'escalation' => Yii::t('app', 'Escalation'),
            'location_name_override' => Yii::t('app', 'Location Name Override'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_last_sync' => Yii::t('app', 'Date Last Sync'),
            'provider_practice_listing_id' => null,
            'added_by_account_id' => Yii::t('app', 'Added By Account'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'place_id' => Yii::t('app', 'Place'),
            'category_1' => Yii::t('app', 'Category 1'),
            'category_2' => Yii::t('app', 'Category 2'),
            'category_3' => Yii::t('app', 'Category 3'),
            'link_verified' => Yii::t('app', 'Link Verified'),
            'sync_tracking_number' => Yii::t('app', 'Sync Tracking Number'),
            'sync_cover' => Yii::t('app', 'Sync Cover'),
            'sync_address' => Yii::t('app', 'Sync Address'),
            'sync_website' => Yii::t('app', 'Sync Website'),
            'skip' => Yii::t('app', 'Skip'),
            'create' => Yii::t('app', 'Create'),
            'merge' => Yii::t('app', 'Merge'),
            'close' => Yii::t('app', 'Close'),
            'verify' => Yii::t('app', 'Verify'),
            'claim' => Yii::t('app', 'Claim'),
            'request_ownership' => Yii::t('app', 'Request Ownership'),
            'integrate' => Yii::t('app', 'Integrate'),
            'gmbLocations' => null,
            'gmbLocationStats' => null,
            'account' => null,
            'practice' => null,
            'provider' => null,
            'providerPracticeListing' => null,
            'providerPracticeGmbDataPoints' => null,
            'providerPracticeGmbLocationStates' => null,
            'providerPracticeGmbVerifications' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('is_read_only', $this->is_read_only);
        $criteria->compare('apply_dr_booking_url', $this->apply_dr_booking_url);
        $criteria->compare('apply_dr_description', $this->apply_dr_description);
        $criteria->compare('has_sync_issues', $this->has_sync_issues);
        $criteria->compare('sync_issues_details', $this->sync_issues_details, true);
        $criteria->compare('has_localposts_api', $this->has_localposts_api);
        $criteria->compare('is_claimed_by', $this->is_claimed_by, true);
        $criteria->compare('escalation', $this->escalation, true);
        $criteria->compare('location_name_override', $this->location_name_override, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('date_last_sync', $this->date_last_sync, true);
        $criteria->compare('provider_practice_listing_id', $this->provider_practice_listing_id);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);
        $criteria->compare('place_id', $this->place_id, true);
        $criteria->compare('category_1', $this->category_1, true);
        $criteria->compare('category_2', $this->category_2, true);
        $criteria->compare('category_3', $this->category_3, true);
        $criteria->compare('link_verified', $this->link_verified);
        $criteria->compare('sync_tracking_number', $this->sync_tracking_number);
        $criteria->compare('sync_cover', $this->sync_cover);
        $criteria->compare('sync_address', $this->sync_address);
        $criteria->compare('sync_website', $this->sync_website);
        $criteria->compare('skip', $this->skip);
        $criteria->compare('create', $this->create);
        $criteria->compare('merge', $this->merge);
        $criteria->compare('close', $this->close);
        $criteria->compare('verify', $this->verify);
        $criteria->compare('claim', $this->claim);
        $criteria->compare('request_ownership', $this->request_ownership);
        $criteria->compare('integrate', $this->integrate);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
